--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -1818,38 +2348,45 @@
                 sarray, strip_len);
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // SpotLightRetained methods
+    //
+
     // non interleaved, by reference, nio buffer
     @Override
     void executeIndexedGeometryVABuffer(Context ctx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean ignoreVertexColors,
-            int initialIndexIndex,
-            int validIndexCount,
-            int vertexCount,
-            int vformat,
-            int vdefined,
-            Buffer vcoords,
-            Buffer cdataBuffer,
-            float[] cfdata, byte[] cbdata,
-            FloatBuffer ndata,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            FloatBuffer[] vertexAttrData,
-            int texCoordMapLength,
-            int[] texcoordoffset,
-            int numActiveTexUnitState,
-            int texStride, Object[] texCoords,
-            int cdirty,
-            int[] indexCoord) {
+                                        GeometryArrayRetained geo, int geo_type,
+                                        boolean isNonUniformScale,
+                                        boolean ignoreVertexColors,
+                                        int initialIndexIndex,
+                                        int validIndexCount,
+                                        int vertexCount,
+                                        int vformat,
+                                        int vdefined,
+                                        Buffer vcoords,
+                                        Buffer cdataBuffer,
+                                        float[] cfdata, byte[] cbdata,
+                                        FloatBuffer ndata,
+                                        int vertexAttrCount, int[] vertexAttrSizes,
+                                        FloatBuffer[] vertexAttrData,
+                                        int texCoordMapLength,
+                                        int[] texcoordoffset,
+                                        int numActiveTexUnitState,
+                                        int texStride, Object[] texCoords,
+                                        int cdirty,
+                                        int[] indexCoord) {
         if (VERBOSE) System.err.println("JoglPipeline.executeIndexedGeometryVABuffer()");
 
-        boolean floatCoordDefined  = ((vdefined & GeometryArrayRetained.COORD_FLOAT)    != 0);
-        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE)   != 0);
-        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT)    != 0);
-        boolean byteColorsDefined  = ((vdefined & GeometryArrayRetained.COLOR_BYTE)     != 0);
-        boolean normalsDefined     = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT)   != 0);
-        boolean vattrDefined       = ((vdefined & GeometryArrayRetained.VATTR_FLOAT)    != 0);
-        boolean textureDefined     = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
+        boolean floatCoordDefined = ((vdefined & GeometryArrayRetained.COORD_FLOAT) != 0);
+        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE) != 0);
+        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT) != 0);
+        boolean byteColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_BYTE) != 0);
+        boolean normalsDefined = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT) != 0);
+        boolean vattrDefined = ((vdefined & GeometryArrayRetained.VATTR_FLOAT) != 0);
+        boolean textureDefined = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
 
         FloatBuffer fverts = null;
         DoubleBuffer dverts = null;
@@ -1886,7 +2423,7 @@
         int[] sarray = null;
         int strip_len = 0;
         if (geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_INDEXED_LINE_STRIP_SET) {
             sarray = ((IndexedGeometryStripArrayRetained) geo).stripIndexCounts;
             strip_len = sarray.length;
@@ -1925,27 +2462,34 @@
                 sarray, strip_len);
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // ExponentialFogRetained methods
+    //
+
     // by-copy geometry
     @Override
     void buildIndexedGeometry(Context absCtx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale, boolean updateAlpha,
-            float alpha,
-            boolean ignoreVertexColors,
-            int initialIndexIndex,
-            int validIndexCount,
-            int vertexCount,
-            int vformat,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            int texCoordSetCount, int[] texCoordSetMap,
-            int texCoordSetMapLen,
-            int[] texCoordSetMapOffset,
-            double[] xform, double[] nxform,
-            float[] varray, int[] indexCoord) {
+                              GeometryArrayRetained geo, int geo_type,
+                              boolean isNonUniformScale, boolean updateAlpha,
+                              float alpha,
+                              boolean ignoreVertexColors,
+                              int initialIndexIndex,
+                              int validIndexCount,
+                              int vertexCount,
+                              int vformat,
+                              int vertexAttrCount, int[] vertexAttrSizes,
+                              int texCoordSetCount, int[] texCoordSetMap,
+                              int texCoordSetMapLen,
+                              int[] texCoordSetMapOffset,
+                              double[] xform, double[] nxform,
+                              float[] varray, int[] indexCoord) {
         if (VERBOSE) System.err.println("JoglPipeline.buildIndexedGeometry()");
 
         JoglContext ctx = (JoglContext) absCtx;
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         boolean useInterleavedArrays;
         int iaFormat = 0;
@@ -1956,7 +2500,7 @@
         int vAttrStride = 0;
         int bstride = 0, cbstride = 0;
         FloatBuffer verts = null;
-        FloatBuffer clrs  = null;
+        FloatBuffer clrs = null;
         int[] sarray = null;
         int strip_len = 0;
         boolean useAlpha = false;
@@ -2013,7 +2557,7 @@
             texCoordoff += vAttrStride;
         }
 
-		bstride = stride * Buffers.SIZEOF_FLOAT;
+        bstride = stride * Buffers.SIZEOF_FLOAT;
 
         // process alpha for geometryArray without alpha
         if (updateAlpha && !ignoreVertexColors) {
@@ -2021,7 +2565,7 @@
         }
 
         if (geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_INDEXED_LINE_STRIP_SET) {
             sarray = ((IndexedGeometryStripArrayRetained) geo).stripIndexCounts;
             strip_len = sarray.length;
@@ -2033,16 +2577,16 @@
         // Apply normal transform if necessary
         if ((vformat & GeometryArray.NORMALS) != 0 && nxform != null) {
             int off = normoff;
-            for (int i = 0; i < vertexCount * 3; i+=3) {
-                verts.put(off  , (float) (nxform[0] * varray[off] +
-                        nxform[1] * varray[off+1] +
-                        nxform[2] * varray[off+2]));
-                verts.put(off+1, (float) (nxform[4] * varray[off] +
-                        nxform[5] * varray[off+1] +
-                        nxform[6] * varray[off+2]));
-                verts.put(off+2, (float) (nxform[8] * varray[off] +
-                        nxform[9] * varray[off+1] +
-                        nxform[10] * varray[off+2]));
+            for (int i = 0; i < vertexCount * 3; i += 3) {
+                verts.put(off, (float) (nxform[0] * varray[off] +
+                        nxform[1] * varray[off + 1] +
+                        nxform[2] * varray[off + 2]));
+                verts.put(off + 1, (float) (nxform[4] * varray[off] +
+                        nxform[5] * varray[off + 1] +
+                        nxform[6] * varray[off + 2]));
+                verts.put(off + 2, (float) (nxform[8] * varray[off] +
+                        nxform[9] * varray[off + 1] +
+                        nxform[10] * varray[off + 2]));
                 off += stride;
             }
         }
@@ -2050,29 +2594,29 @@
         // Apply coordinate transform if necessary
         if ((vformat & GeometryArray.COORDINATES) != 0 && xform != null) {
             int off = coordoff;
-            for (int i = 0; i < vertexCount * 3; i+=3) {
-                verts.put(off  , (float) (xform[0] * varray[off] +
-                        xform[1] * varray[off+1] +
-                        xform[2] * varray[off+2]));
-                verts.put(off+1, (float) (xform[4] * varray[off] +
-                        xform[5] * varray[off+1] +
-                        xform[6] * varray[off+2]));
-                verts.put(off+2, (float) (xform[8] * varray[off] +
-                        xform[9] * varray[off+1] +
-                        xform[10] * varray[off+2]));
+            for (int i = 0; i < vertexCount * 3; i += 3) {
+                verts.put(off, (float) (xform[0] * varray[off] +
+                        xform[1] * varray[off + 1] +
+                        xform[2] * varray[off + 2]));
+                verts.put(off + 1, (float) (xform[4] * varray[off] +
+                        xform[5] * varray[off + 1] +
+                        xform[6] * varray[off + 2]));
+                verts.put(off + 2, (float) (xform[8] * varray[off] +
+                        xform[9] * varray[off + 1] +
+                        xform[10] * varray[off + 2]));
                 off += stride;
             }
         }
 
         if (geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_INDEXED_LINE_STRIP_SET) {
             // Note we can use interleaved arrays even if we have a
             // non-null xform since we use the same data layout unlike the
             // C code
             if (ignoreVertexColors ||
                     (((vformat & GeometryArray.TEXTURE_COORDINATE) != 0) && ((texCoordSetMapLen > 1) ||
-                    (texCoordSetCount > 1)))) {
+                            (texCoordSetCount > 1)))) {
                 useInterleavedArrays = false;
             } else {
                 boolean[] tmp = new boolean[1];
@@ -2155,7 +2699,7 @@
             // C code
             if (ignoreVertexColors ||
                     (((vformat & GeometryArray.TEXTURE_COORDINATE) != 0) && ((texCoordSetMapLen > 1) ||
-                    (texCoordSetCount > 1)))) {
+                            (texCoordSetCount > 1)))) {
                 useInterleavedArrays = false;
             } else {
                 boolean[] tmp = new boolean[1];
@@ -2205,16 +2749,16 @@
                 }
 
                 switch (geo_type) {
-                    case GeometryRetained.GEO_TYPE_INDEXED_QUAD_SET :
+                    case GeometryRetained.GEO_TYPE_INDEXED_QUAD_SET:
                         primType = GL2.GL_QUADS;
                         break;
-                    case GeometryRetained.GEO_TYPE_INDEXED_TRI_SET :
+                    case GeometryRetained.GEO_TYPE_INDEXED_TRI_SET:
                         primType = GL.GL_TRIANGLES;
                         break;
-                    case GeometryRetained.GEO_TYPE_INDEXED_POINT_SET :
+                    case GeometryRetained.GEO_TYPE_INDEXED_POINT_SET:
                         primType = GL.GL_POINTS;
                         break;
-                    case GeometryRetained.GEO_TYPE_INDEXED_LINE_SET :
+                    case GeometryRetained.GEO_TYPE_INDEXED_LINE_SET:
                         primType = GL.GL_LINES;
                         break;
                 }
@@ -2239,29 +2783,30 @@
     }
 
 
-    //----------------------------------------------------------------------
+    // ---------------------------------------------------------------------
+
     //
-    // Helper routines for IndexedGeometryArrayRetained
+    // LinearFogRetained methods
     //
 
     private void executeIndexedGeometryArray(Context absCtx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean useAlpha,
-            boolean ignoreVertexColors,
-            int initialIndexIndex,
-            int indexCount,
-            int vertexCount, int vformat,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            int texCoordSetCount, int[] texCoordSetMap,
-            int texCoordSetMapLen,
-            int[] texCoordSetOffset,
-            int numActiveTexUnitState,
-            float[] varray, FloatBuffer vdata, float[] carray,
-            int cDirty,
-            int[] indexCoord) {
+                                             GeometryArrayRetained geo, int geo_type,
+                                             boolean isNonUniformScale,
+                                             boolean useAlpha,
+                                             boolean ignoreVertexColors,
+                                             int initialIndexIndex,
+                                             int indexCount,
+                                             int vertexCount, int vformat,
+                                             int vertexAttrCount, int[] vertexAttrSizes,
+                                             int texCoordSetCount, int[] texCoordSetMap,
+                                             int texCoordSetMapLen,
+                                             int[] texCoordSetOffset,
+                                             int numActiveTexUnitState,
+                                             float[] varray, FloatBuffer vdata, float[] carray,
+                                             int cDirty,
+                                             int[] indexCoord) {
         JoglContext ctx = (JoglContext) absCtx;
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         boolean useInterleavedArrays;
         int iaFormat = 0;
@@ -2272,7 +2817,7 @@
         int vAttrStride = 0;
         int bstride = 0, cbstride = 0;
         FloatBuffer verts = null;
-        FloatBuffer clrs  = null;
+        FloatBuffer clrs = null;
         int[] sarray = null;
         int strip_len = 0;
 
@@ -2324,10 +2869,10 @@
             texCoordoff += vAttrStride;
         }
 
-		bstride = stride * Buffers.SIZEOF_FLOAT;
+        bstride = stride * Buffers.SIZEOF_FLOAT;
 
         if (geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_INDEXED_LINE_STRIP_SET) {
             sarray = ((IndexedGeometryStripArrayRetained) geo).stripIndexCounts;
             strip_len = sarray.length;
@@ -2353,7 +2898,7 @@
             clrs = verts;
         }
 
-		cbstride = cstride * Buffers.SIZEOF_FLOAT;
+        cbstride = cstride * Buffers.SIZEOF_FLOAT;
 
         // Enable normalize for non-uniform scale (which rescale can't handle)
         if (isNonUniformScale) {
@@ -2362,11 +2907,11 @@
 
         /*** Handle non-indexed strip GeometryArray first *******/
         if (geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_INDEXED_LINE_STRIP_SET) {
             if (ignoreVertexColors || (carray != null) ||
                     ((vformat & GeometryArray.TEXTURE_COORDINATE) != 0 && ((texCoordSetMapLen > 1) ||
-                    (texCoordSetCount > 1)))) {
+                            (texCoordSetCount > 1)))) {
                 useInterleavedArrays = false;
             } else {
                 boolean[] tmp = new boolean[1];
@@ -2451,7 +2996,7 @@
             /******* Handle non-indexed non-striped GeometryArray now *****/
             if (ignoreVertexColors || (carray != null) ||
                     ((vformat & GeometryArray.TEXTURE_COORDINATE) != 0 && ((texCoordSetMapLen > 1) ||
-                    (texCoordSetCount > 1)))) {
+                            (texCoordSetCount > 1)))) {
                 useInterleavedArrays = false;
             } else {
                 boolean[] tmp = new boolean[1];
@@ -2509,11 +3054,19 @@
             lockArray(gl, vertexCount);
             IntBuffer buf = IntBuffer.wrap(indexCoord);
             buf.position(initialIndexIndex);
-            switch (geo_type){
-                case GeometryRetained.GEO_TYPE_INDEXED_QUAD_SET : gl.glDrawElements(GL2.GL_QUADS,     indexCount, GL.GL_UNSIGNED_INT, buf); break;
-                case GeometryRetained.GEO_TYPE_INDEXED_TRI_SET  : gl.glDrawElements(GL.GL_TRIANGLES, indexCount, GL.GL_UNSIGNED_INT, buf); break;
-                case GeometryRetained.GEO_TYPE_INDEXED_POINT_SET: gl.glDrawElements(GL.GL_POINTS,    indexCount, GL.GL_UNSIGNED_INT, buf); break;
-                case GeometryRetained.GEO_TYPE_INDEXED_LINE_SET : gl.glDrawElements(GL.GL_LINES,     indexCount, GL.GL_UNSIGNED_INT, buf); break;
+            switch (geo_type) {
+                case GeometryRetained.GEO_TYPE_INDEXED_QUAD_SET:
+                    gl.glDrawElements(GL2.GL_QUADS, indexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
+                case GeometryRetained.GEO_TYPE_INDEXED_TRI_SET:
+                    gl.glDrawElements(GL.GL_TRIANGLES, indexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
+                case GeometryRetained.GEO_TYPE_INDEXED_POINT_SET:
+                    gl.glDrawElements(GL.GL_POINTS, indexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
+                case GeometryRetained.GEO_TYPE_INDEXED_LINE_SET:
+                    gl.glDrawElements(GL.GL_LINES, indexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
             }
         }
 
@@ -2534,32 +3087,38 @@
     }
 
 
+    // ---------------------------------------------------------------------
+
+    //
+    // LineAttributesRetained methods
+    //
+
     private void executeIndexedGeometryArrayVA(Context absCtx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean ignoreVertexColors,
-            int initialIndexIndex,
-            int validIndexCount,
-            int vertexCount, int vformat, int vdefined,
-            FloatBuffer fverts, DoubleBuffer dverts,
-            FloatBuffer fclrs, ByteBuffer bclrs,
-            FloatBuffer norms,
-            int vertexAttrCount, int[] vertexAttrSizes, FloatBuffer[] vertexAttrBufs,
-            int texCoordSetCount, int[] texCoordSetMap,
-            int numActiveTexUnitState,
-            int texStride,
-            FloatBuffer[] texCoords,
-            int cDirty, int[] indexCoord, int[] sarray, int strip_len) {
+                                               GeometryArrayRetained geo, int geo_type,
+                                               boolean isNonUniformScale,
+                                               boolean ignoreVertexColors,
+                                               int initialIndexIndex,
+                                               int validIndexCount,
+                                               int vertexCount, int vformat, int vdefined,
+                                               FloatBuffer fverts, DoubleBuffer dverts,
+                                               FloatBuffer fclrs, ByteBuffer bclrs,
+                                               FloatBuffer norms,
+                                               int vertexAttrCount, int[] vertexAttrSizes, FloatBuffer[] vertexAttrBufs,
+                                               int texCoordSetCount, int[] texCoordSetMap,
+                                               int numActiveTexUnitState,
+                                               int texStride,
+                                               FloatBuffer[] texCoords,
+                                               int cDirty, int[] indexCoord, int[] sarray, int strip_len) {
         JoglContext ctx = (JoglContext) absCtx;
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
-        boolean floatCoordDefined  = ((vdefined & GeometryArrayRetained.COORD_FLOAT)    != 0);
-        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE)   != 0);
-        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT)    != 0);
-        boolean byteColorsDefined  = ((vdefined & GeometryArrayRetained.COLOR_BYTE)     != 0);
-        boolean normalsDefined     = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT)   != 0);
-        boolean vattrDefined       = ((vdefined & GeometryArrayRetained.VATTR_FLOAT)    != 0);
-        boolean textureDefined     = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
+        boolean floatCoordDefined = ((vdefined & GeometryArrayRetained.COORD_FLOAT) != 0);
+        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE) != 0);
+        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT) != 0);
+        boolean byteColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_BYTE) != 0);
+        boolean normalsDefined = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT) != 0);
+        boolean vattrDefined = ((vdefined & GeometryArrayRetained.VATTR_FLOAT) != 0);
+        boolean textureDefined = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
 
         // Enable normalize for non-uniform scale (which rescale can't handle)
         if (isNonUniformScale) {
@@ -2570,7 +3129,7 @@
         if (floatCoordDefined) {
             fverts.position(0);
             gl.glVertexPointer(3, GL.GL_FLOAT, 0, fverts);
-        } else if (doubleCoordDefined){
+        } else if (doubleCoordDefined) {
             dverts.position(0);
             gl.glVertexPointer(3, GL2.GL_DOUBLE, 0, dverts);
         }
@@ -2625,7 +3184,7 @@
         lockArray(gl, vertexCount);
 
         if (geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_INDEXED_LINE_STRIP_SET) {
             int primType = 0;
             switch (geo_type) {
@@ -2654,11 +3213,19 @@
         } else {
             IntBuffer buf = IntBuffer.wrap(indexCoord);
             buf.position(initialIndexIndex);
-            switch (geo_type){
-                case GeometryRetained.GEO_TYPE_INDEXED_QUAD_SET : gl.glDrawElements(GL2.GL_QUADS,     validIndexCount, GL.GL_UNSIGNED_INT, buf); break;
-                case GeometryRetained.GEO_TYPE_INDEXED_TRI_SET  : gl.glDrawElements(GL.GL_TRIANGLES, validIndexCount, GL.GL_UNSIGNED_INT, buf); break;
-                case GeometryRetained.GEO_TYPE_INDEXED_POINT_SET: gl.glDrawElements(GL.GL_POINTS,    validIndexCount, GL.GL_UNSIGNED_INT, buf); break;
-                case GeometryRetained.GEO_TYPE_INDEXED_LINE_SET : gl.glDrawElements(GL.GL_LINES,     validIndexCount, GL.GL_UNSIGNED_INT, buf); break;
+            switch (geo_type) {
+                case GeometryRetained.GEO_TYPE_INDEXED_QUAD_SET:
+                    gl.glDrawElements(GL2.GL_QUADS, validIndexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
+                case GeometryRetained.GEO_TYPE_INDEXED_TRI_SET:
+                    gl.glDrawElements(GL.GL_TRIANGLES, validIndexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
+                case GeometryRetained.GEO_TYPE_INDEXED_POINT_SET:
+                    gl.glDrawElements(GL.GL_POINTS, validIndexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
+                case GeometryRetained.GEO_TYPE_INDEXED_LINE_SET:
+                    gl.glDrawElements(GL.GL_LINES, validIndexCount, GL.GL_UNSIGNED_INT, buf);
+                    break;
             }
         }
 
@@ -2682,28 +3249,28 @@
     // ---------------------------------------------------------------------
 
     //
-    // GraphicsContext3D methods
+    // MaterialRetained methods
     //
 
     // Native method for readRaster
     @Override
     void readRaster(Context ctx,
-            int type, int xSrcOffset, int ySrcOffset,
-            int width, int height, int hCanvas,
-            int imageDataType,
-            int imageFormat,
-            Object imageBuffer,
-            int depthFormat,
-            Object depthBuffer) {
+                    int type, int xSrcOffset, int ySrcOffset,
+                    int width, int height, int hCanvas,
+                    int imageDataType,
+                    int imageFormat,
+                    Object imageBuffer,
+                    int depthFormat,
+                    Object depthBuffer) {
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glPixelStorei(GL2.GL_PACK_ROW_LENGTH, width);
         gl.glPixelStorei(GL.GL_PACK_ALIGNMENT, 1);
         int yAdjusted = hCanvas - height - ySrcOffset;
 
         if ((type & Raster.RASTER_COLOR) != 0) {
             int oglFormat = 0;
-            if(imageDataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
+            if (imageDataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
 
                 switch (imageFormat) {
                     case ImageComponentRetained.TYPE_BYTE_BGR:
@@ -2742,7 +3309,7 @@
                         oglFormat, GL.GL_UNSIGNED_BYTE, ByteBuffer.wrap((byte[]) imageBuffer));
 
 
-            } else if(imageDataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
+            } else if (imageDataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
                 int intType = GL2.GL_UNSIGNED_INT_8_8_8_8;
                 boolean forceAlphaToOne = false;
 
@@ -2760,7 +3327,7 @@
                         oglFormat = GL2.GL_BGRA;
                         intType = GL2.GL_UNSIGNED_INT_8_8_8_8_REV;
                         break;
-                        /* This method only supports 3 and 4 components formats and INT types. */
+                    /* This method only supports 3 and 4 components formats and INT types. */
                     case ImageComponentRetained.TYPE_BYTE_LA:
                     case ImageComponentRetained.TYPE_BYTE_GRAY:
                     case ImageComponentRetained.TYPE_USHORT_GRAY:
@@ -2774,7 +3341,7 @@
                 }
 
                 /* Force Alpha to 1.0 if needed */
-                if(forceAlphaToOne) {
+                if (forceAlphaToOne) {
                     gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 0.0f);
                     gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 1.0f);
                 }
@@ -2783,7 +3350,7 @@
                         oglFormat, intType, IntBuffer.wrap((int[]) imageBuffer));
 
                 /* Restore Alpha scale and bias */
-                if(forceAlphaToOne) {
+                if (forceAlphaToOne) {
                     gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 1.0f);
                     gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 0.0f);
                 }
